import UIView from '@gec/ui-view';
export default class UIColFix extends UIView {
    constructor(options = {}) {
        super(options);
        var element = this.el;
        var child = element.getAttribute('data-child');
        var fixToSelector = element.getAttribute('data-fixto');
        var fixToElement = document.querySelector(fixToSelector) || element.parentElement;


        element.insertAdjacentHTML('beforebegin', '<i/>');

        var prev = element.previousElementSibling;
        var DSupBase = prev.getBoundingClientRect().top;
        var DInfBase = fixToElement.getBoundingClientRect().top + outerHeight(fixToElement) - (outerHeight(element));

        function outerHeight(elm) {
            var height = elm.offsetHeight;
            var style = getComputedStyle(elm);

            height += parseInt(style.marginTop) + parseInt(style.marginBottom);
            return height;
        }



        var elementDistance = function elementDistance() {


            var DocS = window.pageYOffset;

            if (DocS >= DSupBase) {
                element.classList.remove('ui-colabsoluted');
                element.classList.add('ui-colfixed');
                element.style.top = 0;
                if (child) {
                    element.style.width = 'inherit';
                }

                if (DocS >= DInfBase) {
                    element.classList.add('ui-colabsoluted');
                    element.classList.remove('ui-colfixed');

                }

            } else {

                element.style.top = '';
                element.classList.remove('ui-colfixed');
                element.classList.remove('ui-colabsoluted');
            }

        };


        addEventListener("scroll", elementDistance);


    }
}