'use strict';

Object.defineProperty(exports, "__esModule", {
        value: true
});

var _uiView = require('@gec/ui-view');

var _uiView2 = _interopRequireDefault(_uiView);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var UIColFix = function (_UIView) {
        _inherits(UIColFix, _UIView);

        function UIColFix() {
                var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

                _classCallCheck(this, UIColFix);

                var _this = _possibleConstructorReturn(this, (UIColFix.__proto__ || Object.getPrototypeOf(UIColFix)).call(this, options));

                var element = _this.el;
                var child = element.getAttribute('data-child');
                var fixToSelector = element.getAttribute('data-fixto');
                var fixToElement = document.querySelector(fixToSelector) || element.parentElement;

                element.insertAdjacentHTML('beforebegin', '<i/>');

                var prev = element.previousElementSibling;
                var DSupBase = prev.getBoundingClientRect().top;
                var DInfBase = fixToElement.getBoundingClientRect().top + outerHeight(fixToElement) - outerHeight(element);

                function outerHeight(elm) {
                        var height = elm.offsetHeight;
                        var style = getComputedStyle(elm);

                        height += parseInt(style.marginTop) + parseInt(style.marginBottom);
                        return height;
                }

                var elementDistance = function elementDistance() {

                        var DocS = window.pageYOffset;

                        if (DocS >= DSupBase) {
                                element.classList.remove('ui-colabsoluted');
                                element.classList.add('ui-colfixed');
                                element.style.top = 0;
                                if (child) {
                                        element.style.width = 'inherit';
                                }

                                if (DocS >= DInfBase) {
                                        element.classList.add('ui-colabsoluted');
                                        element.classList.remove('ui-colfixed');
                                }
                        } else {

                                element.style.top = '';
                                element.classList.remove('ui-colfixed');
                                element.classList.remove('ui-colabsoluted');
                        }
                };

                addEventListener("scroll", elementDistance);

                return _this;
        }

        return UIColFix;
}(_uiView2.default);

exports.default = UIColFix;